mod Ex08b

incl Mtex

incl Mtexrc

loc rem 
  \para \bf  8. CVIČENIE Z PREDMETU 1-AIN-625 ÚVOD DO MATEMATICKEJ LOGIKY PRE 
  PROGRAMÁTOROV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.19 
  \para* \it  Dátum:  \end utorok 15.11.2011 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-625-lpp/1112zs/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Úvodná poznámka.  \end Toto cvičenie je venované obecne 
  rekurzívnym funkciam. Zadanie sa skladá z týchto súborov: 
  \items 
   \item \para Súbor(y) \it  mtex*.cl  \end obsahuje makrá pre CL-TeX. 
   \item \para Súbor(y) \it  maux*.cl  \end obsahuje definície niektorých 
         funkcií a predikátov. 
   \item \para Súbor(y) \it  ex*.cl  \end obsahuje úlohy, ktoré máte 
         riešiť na tomto cvičení. 
   \item \para Súbor \it  msyntax.cl  \end obsahuje syntax systému CL. 
  \end
  \para Tieto súbory sa musia skompilovať v správnom poradí. Presný postup 
  je uvedený v súbore \it  readme.txt  \end. 

loc rem 
  \para \bf  Hodnotenie.  \end 
  \items 
   \item \para Počet bodov za úlohy v tomto súbore: 1 
   \item \para Počet bodov za prémiove úlohy v tomto súbore:: 0 
  \end
  \para Odovzdať do 28.11.2011 (pondelok) do 12:00. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara. Recursive Functions. Downloadable 
         lecture notes available through the web page of the course. 
   \item \para \it  [2]  \end J. Komara and P. J. Voda. Lecture Notes in Theory 
         of Computability. 2001. 
   \item \para \it  [3]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
   \item \para \it  [4]  \end I. Korec. Úvod do teórie algoritmov. Skriptá 
         MFF UK, 1981. 
  \end

rem 
  \para \bf  Chapter. General Recursive Functions.  \end 

rem 
  \para \bf  Section. General Recursive Functions.  \end 

rem 
  \para \bf  Definition.  \end General recursive functions is the smallest class 
  of functions containing the successor \ft x+1 \end and predecessor 
  \ft x-1 \end functions, and is closed under explicit definitions and regular 
  recursive definitions. 

rem 
  \para \bf  Theorem.  \end The class of general recursive functions is 
  primitively recursively closed. 

rem 
  \para \bf  Corollary.  \end We have 
  \items 
   \item \para every primitive recursive function and predicate is general 
         recursive, 
   \item \para general recursive functions are closed under bounded 
         minimalization, 
   \item \para general recursive predicates are closed under explicit 
         definitions of predicates with bounded formulas, 
  \end

rem 
  \para \bf  Subsection. Regular Minimalization.  \end 

rem 
  \para \bf  Definitions of functions with regular minimalization.  \end 

rem 
  \para \bf  [CL] Syntax.  \end \header* pred/2 R  \end Example(s): 
  \def 
    fun F 'Tex_f1_f'
    F(x) = \m y [ R(x,y) ]
  \end
  \para provided the following condition of regularity is satisfied: 
  \eq* 
    \a x\e yR(x,y)
  \end

rem 
  \para \bf  Exercise. \it  (1 point)  \end  \end Show that general recursive 
  functions are closed under regular minimalization. 
  \para \it  Remark.  \end Prove the claim for the special case in the following 
  theory. 

theory Regular_minimalization

pred/2 R 

rem 
  \para \header* fun F 'Tex_f1_f' \end Show that if \ft R(x,y) \end is a general 
  recursive predicate such that 
  \eq* 
    \a x\e yR(x,y)
  \end
  \para then so is the function \ft F(x) \end defined by regular minimalization: 

fun F 'Tex_f1_f'
  F(x) = \m y [ R(x,y) ]

rem 
  \para \it  Proof.  \end 

fun F_is_grec 'Tex_f1_f'
  F_is_grec(x) = Foo

end theory Regular_minimalization

rem 
  \para \bf  [CL] Remark.  \end You can test your solution by \it  interpreting 
   \end the theory. Choose \it  non-local  \end interpretation. 

rem 
  \para \bf  Theorem.  \end General recursive functions are closed under 
  definitions of functions with regular minimalization. 

loc rem 
  ******************************************************************************
  ********************************* DEBUGGING **********************************
  ******************************************************************************

loc fun Test_fun 
  Test_fun(x) = Foo

loc fun/2 Itfa 
  Itfa(0,a) = a
  Itfa(n+1,a) = Itfa(n,(n,Test_fun(n)),a)

loc fun Itf 
  Itf(n) = Itfa(n,0)

loc pred Test_pred 
  Test_pred(x) <-> Poo

loc fun/2 Itpa 
  Itpa(0,a) = a
  Itpa(n+1,a) = Itpa(n,n,a) <- Test_pred(n)
  Itpa(n+1,a) = Itpa(n,a) <- ~Test_pred(n)

loc fun Itp 
  Itp(n) = Itpa(n,0)

